using System;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Security.Permissions;

namespace Bon
{
	[Serializable]
	[ComVisible(true)]
	[Guid("330ADCAE-013D-4995-8542-A7FCB999B439")]
	[ComDefaultInterface(typeof(_Exception))]
	public class BonException : Exception
	{
		public BonException(string format, params object[] args)
			: base(string.Format(format, args))
		{
		}

		public BonException(Exception inner, string format, params object[] args)
			: base(string.Format(format, args), inner)
		{
		}

		[SecurityPermission(SecurityAction.Demand, SerializationFormatter = true)]
		protected BonException(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
		}
	}
}
