using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("99DD6FA8-12A5-464c-8DB0-511FDA6C06D7")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IDataQueue : IDisposable
	{
		void Clear();

		[ComVisible(false)]
		[Browsable(false)]
		WaitHandle CanDequeue
		{
			get;
		}

		[Browsable(false)]
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		IntPtr CanDequeueHandle
		{
			get;
		}
		
		int Count
		{
			get;
		}

		long MaxSize
		{
			get;
		}

		long TotalSize
		{
			get;
		}

		ITsData Dequeue();

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		IRawTsData RawDequeue();
	}
}
