using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("C2B1511F-079E-499f-9F5F-122180844AD4")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IProgramInformation
	{
		int ProgramID
		{
			get;
		}

		int ProgramVideoID
		{
			get;
		}

		int ProgramAudioID
		{
			get;
		}

		int ProgramPcrID
		{
			get;
		}

		string ServiceName
		{
			get;
		}

		IEpgData EpgData
		{
			get;
		}
	}
}
