
#pragma once

#include "TsData.h"

namespace Bon
{
	ref class RawTsData sealed
		: public IRawTsData
	{
	private:
		ITsData^ data_;
		System::Runtime::InteropServices::GCHandle handle_;

	internal:
		RawTsData(ITsData^ data);

	public:
		~RawTsData();

		property int Size
		{
			virtual int get();
		}

		property array<System::Byte>^ Data
		{
			virtual array<System::Byte>^ get();
		}

		property System::IntPtr RawData
		{
			virtual System::IntPtr get();
		}
	};
}
