// BonGlobal.h: O[o֐`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// O[o֐錾 (IuWFNg\bh)
/////////////////////////////////////////////////////////////////////////////

#include <typeinfo.h>


// BonRAGWAPI
extern "C"
{

	BONAPI const Bon::BONGUID BON_NAME_TO_GUID(LPCTSTR lpszName);
	BONAPI Bon::IBonObject * BON_CREATE_INSTANCE(LPCTSTR lpszClassName, Bon::IBonObject *pOwner);

	BONAPI const bool QUERY_BON_MODULE(LPCTSTR lpszModuleName);
	BONAPI void GET_BON_MODULE_NAME(const Bon::BONGUID ModuleId, CBonString *pModuleName);

	BONAPI const bool REGISTER_BON_CLASS(LPCTSTR lpszClassName, const Bon::CLASSFACTORYMETHOD pfnClassFactory, const DWORD dwPriority);
	BONAPI const bool QUERY_BON_CLASS(LPCTSTR lpszClassName);
	BONAPI void GET_BON_CLASS_NAME(const Bon::BONGUID ClassId, CBonString *pClassName);
	BONAPI const Bon::BONGUID GET_BON_CLASS_MODULE(const Bon::BONGUID ClassId);

	BONAPI Bon::IBonObject * GET_STOCK_INSTANCE(LPCTSTR lpszClassName);
	BONAPI const bool REGISTER_STOCK_INSTANCE(LPCTSTR lpszClassName, Bon::IBonObject *pInstance);
	BONAPI const bool UNREGISTER_STOCK_INSTANCE(LPCTSTR lpszClassName);

}


// [eBeB[\bh
template <class T> const bool BON_REGISTER_CLASS(const DWORD dwPriority = 0UL, const bool strict = false)
{
#ifdef _UNICODE
	WCHAR szClassName[BON_MAX_CLASS_NAME] = TEXT("");

	const type_info &ti = typeid(T);
	const char *pName = ti.name();
	if ((strict == false) && (memcmp(pName, "class Bon::", 10) == 0))
	{
		// NXUNICODEɕϊ
		::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pName + 11, -1, szClassName, sizeof(szClassName) / sizeof(*szClassName));
	}
	else
	{
		// NXUNICODEɕϊ
		::MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, pName + 6, -1, szClassName, sizeof(szClassName) / sizeof(*szClassName));
	}

	// NXt@Ng[o^
	return ::REGISTER_BON_CLASS(szClassName, T::CreateInstance, dwPriority);
#else
	const type_info &ti = typeid(T);
	const char *pName = ti.name();
	if ((strict == false) && (memcmp(pName, "class Bon::", 10) == 0))
	{
		// NXt@Ng[o^
		return ::REGISTER_BON_CLASS(pName + 11, T::CreateInstance, dwPriority);
	}
	else
	{
		// NXt@Ng[o^
		return ::REGISTER_BON_CLASS(pName + 6, T::CreateInstance, dwPriority);
	}
#endif
}

template <class T> T BON_SAFE_CREATE(LPCTSTR lpszBCId, Bon::IBonObject *pOwner = NULL)
{
	// CX^X
	Bon::IBonObject *pNewInstance = ::BON_CREATE_INSTANCE(lpszBCId, pOwner);

	// C^tF[X擾
	T pDestInterface = dynamic_cast<T>(pNewInstance);

	// ړĨC^tF[XĂȂꍇ̓CX^XJ
	if(pNewInstance && !pDestInterface)pNewInstance->Release();

	return pDestInterface;
}
