// BonSyncIf.h: IuWFNgC^[tFCX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// NeBJZNVC^[tFCX
/////////////////////////////////////////////////////////////////////////////

class ILockObject
{
public:
	virtual void Lock() const = 0;
	virtual void Unlock() const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// ҋ@\C^[tFCX
/////////////////////////////////////////////////////////////////////////////

class IWaitableObject
{
public:
	enum WaitResult
	{
		Failed = WAIT_FAILED,
		Timeout = WAIT_TIMEOUT,
		Signal0 = WAIT_OBJECT_0 + 0,
		Signal1 = WAIT_OBJECT_0 + 1,
		Signal2 = WAIT_OBJECT_0 + 2,
		Signal3 = WAIT_OBJECT_0 + 3,
		Signal4 = WAIT_OBJECT_0 + 4,
		Signal5 = WAIT_OBJECT_0 + 5,
		Signal6 = WAIT_OBJECT_0 + 6,
		Signal7 = WAIT_OBJECT_0 + 7,
		Signal8 = WAIT_OBJECT_0 + 8,
		Signal9 = WAIT_OBJECT_0 + 9,
		Signal10 = WAIT_OBJECT_0 + 10,
		Signal11 = WAIT_OBJECT_0 + 11,
		Signal12 = WAIT_OBJECT_0 + 12,
		Signal13 = WAIT_OBJECT_0 + 13,
		Signal14 = WAIT_OBJECT_0 + 14,
		Signal15 = WAIT_OBJECT_0 + 15,
		Signal16 = WAIT_OBJECT_0 + 16,
		Signal17 = WAIT_OBJECT_0 + 17,
		Signal18 = WAIT_OBJECT_0 + 18,
		Signal19 = WAIT_OBJECT_0 + 19,
		Signal20 = WAIT_OBJECT_0 + 20,
		Signal21 = WAIT_OBJECT_0 + 21,
		Signal22 = WAIT_OBJECT_0 + 22,
		Signal23 = WAIT_OBJECT_0 + 23,
		Signal24 = WAIT_OBJECT_0 + 24,
		Signal25 = WAIT_OBJECT_0 + 25,
		Signal26 = WAIT_OBJECT_0 + 26,
		Signal27 = WAIT_OBJECT_0 + 27,
		Signal28 = WAIT_OBJECT_0 + 28,
		Signal29 = WAIT_OBJECT_0 + 29,
		Signal30 = WAIT_OBJECT_0 + 30,
		Signal31 = WAIT_OBJECT_0 + 31,
		Signal32 = WAIT_OBJECT_0 + 32,
		Signal33 = WAIT_OBJECT_0 + 33,
		Signal34 = WAIT_OBJECT_0 + 34,
		Signal35 = WAIT_OBJECT_0 + 35,
		Signal36 = WAIT_OBJECT_0 + 36,
		Signal37 = WAIT_OBJECT_0 + 37,
		Signal38 = WAIT_OBJECT_0 + 38,
		Signal39 = WAIT_OBJECT_0 + 39,
		Signal40 = WAIT_OBJECT_0 + 40,
		Signal41 = WAIT_OBJECT_0 + 41,
		Signal42 = WAIT_OBJECT_0 + 42,
		Signal43 = WAIT_OBJECT_0 + 43,
		Signal44 = WAIT_OBJECT_0 + 44,
		Signal45 = WAIT_OBJECT_0 + 45,
		Signal46 = WAIT_OBJECT_0 + 46,
		Signal47 = WAIT_OBJECT_0 + 47,
		Signal48 = WAIT_OBJECT_0 + 48,
		Signal49 = WAIT_OBJECT_0 + 49,
		Signal50 = WAIT_OBJECT_0 + 50,
		Signal51 = WAIT_OBJECT_0 + 51,
		Signal52 = WAIT_OBJECT_0 + 52,
		Signal53 = WAIT_OBJECT_0 + 53,
		Signal54 = WAIT_OBJECT_0 + 54,
		Signal55 = WAIT_OBJECT_0 + 55,
		Signal56 = WAIT_OBJECT_0 + 56,
		Signal57 = WAIT_OBJECT_0 + 57,
		Signal58 = WAIT_OBJECT_0 + 58,
		Signal59 = WAIT_OBJECT_0 + 59,
		Signal60 = WAIT_OBJECT_0 + 60,
		Signal61 = WAIT_OBJECT_0 + 61,
		Signal62 = WAIT_OBJECT_0 + 62,
		Signal63 = WAIT_OBJECT_0 + 63,
		Abondoned0 = WAIT_ABANDONED_0 + 0,
		Abondoned1 = WAIT_ABANDONED_0 + 1,
		Abondoned2 = WAIT_ABANDONED_0 + 2,
		Abondoned3 = WAIT_ABANDONED_0 + 3,
		Abondoned4 = WAIT_ABANDONED_0 + 4,
		Abondoned5 = WAIT_ABANDONED_0 + 5,
		Abondoned6 = WAIT_ABANDONED_0 + 6,
		Abondoned7 = WAIT_ABANDONED_0 + 7,
		Abondoned8 = WAIT_ABANDONED_0 + 8,
		Abondoned9 = WAIT_ABANDONED_0 + 9,
		Abondoned10 = WAIT_ABANDONED_0 + 10,
		Abondoned11 = WAIT_ABANDONED_0 + 11,
		Abondoned12 = WAIT_ABANDONED_0 + 12,
		Abondoned13 = WAIT_ABANDONED_0 + 13,
		Abondoned14 = WAIT_ABANDONED_0 + 14,
		Abondoned15 = WAIT_ABANDONED_0 + 15,
		Abondoned16 = WAIT_ABANDONED_0 + 16,
		Abondoned17 = WAIT_ABANDONED_0 + 17,
		Abondoned18 = WAIT_ABANDONED_0 + 18,
		Abondoned19 = WAIT_ABANDONED_0 + 19,
		Abondoned20 = WAIT_ABANDONED_0 + 20,
		Abondoned21 = WAIT_ABANDONED_0 + 21,
		Abondoned22 = WAIT_ABANDONED_0 + 22,
		Abondoned23 = WAIT_ABANDONED_0 + 23,
		Abondoned24 = WAIT_ABANDONED_0 + 24,
		Abondoned25 = WAIT_ABANDONED_0 + 25,
		Abondoned26 = WAIT_ABANDONED_0 + 26,
		Abondoned27 = WAIT_ABANDONED_0 + 27,
		Abondoned28 = WAIT_ABANDONED_0 + 28,
		Abondoned29 = WAIT_ABANDONED_0 + 29,
		Abondoned30 = WAIT_ABANDONED_0 + 30,
		Abondoned31 = WAIT_ABANDONED_0 + 31,
		Abondoned32 = WAIT_ABANDONED_0 + 32,
		Abondoned33 = WAIT_ABANDONED_0 + 33,
		Abondoned34 = WAIT_ABANDONED_0 + 34,
		Abondoned35 = WAIT_ABANDONED_0 + 35,
		Abondoned36 = WAIT_ABANDONED_0 + 36,
		Abondoned37 = WAIT_ABANDONED_0 + 37,
		Abondoned38 = WAIT_ABANDONED_0 + 38,
		Abondoned39 = WAIT_ABANDONED_0 + 39,
		Abondoned40 = WAIT_ABANDONED_0 + 40,
		Abondoned41 = WAIT_ABANDONED_0 + 41,
		Abondoned42 = WAIT_ABANDONED_0 + 42,
		Abondoned43 = WAIT_ABANDONED_0 + 43,
		Abondoned44 = WAIT_ABANDONED_0 + 44,
		Abondoned45 = WAIT_ABANDONED_0 + 45,
		Abondoned46 = WAIT_ABANDONED_0 + 46,
		Abondoned47 = WAIT_ABANDONED_0 + 47,
		Abondoned48 = WAIT_ABANDONED_0 + 48,
		Abondoned49 = WAIT_ABANDONED_0 + 49,
		Abondoned50 = WAIT_ABANDONED_0 + 50,
		Abondoned51 = WAIT_ABANDONED_0 + 51,
		Abondoned52 = WAIT_ABANDONED_0 + 52,
		Abondoned53 = WAIT_ABANDONED_0 + 53,
		Abondoned54 = WAIT_ABANDONED_0 + 54,
		Abondoned55 = WAIT_ABANDONED_0 + 55,
		Abondoned56 = WAIT_ABANDONED_0 + 56,
		Abondoned57 = WAIT_ABANDONED_0 + 57,
		Abondoned58 = WAIT_ABANDONED_0 + 58,
		Abondoned59 = WAIT_ABANDONED_0 + 59,
		Abondoned60 = WAIT_ABANDONED_0 + 60,
		Abondoned61 = WAIT_ABANDONED_0 + 61,
		Abondoned62 = WAIT_ABANDONED_0 + 62,
		Abondoned63 = WAIT_ABANDONED_0 + 63
	};

	virtual const WaitResult Wait(const DWORD dwTimeout = INFINITE, const bool pumpMessage = false) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// J[lIuWFNgC^[tFCX
/////////////////////////////////////////////////////////////////////////////

class IKernelObject : public IWaitableObject
{
public:
	virtual const bool IsAssigned() const = 0;
	virtual const HANDLE UnsafeGetHandle() const = 0;

	virtual operator const bool() const = 0;
	virtual const bool operator !() const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// J[lIuWFNgANX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CWaitObjectsBase : public IWaitableObject
{
public:
	void Append(const IKernelObject &rhs);
	void Append(const IKernelObject *pRhs);

protected:
	CWaitObjectsBase();
	CWaitObjectsBase(const IKernelObject &rhs);
	CWaitObjectsBase(const IKernelObject *pRhs);
	CWaitObjectsBase(const CWaitObjectsBase &rhs);

	void Copy(const CWaitObjectsBase &rhs);
	const WaitResult Wait(const bool waitAll, const DWORD dwTimeout, const bool pumpMessage) const;

private:
	DWORD m_dwCount;
	HANDLE m_Handles[MAXIMUM_WAIT_OBJECTS];
};


/////////////////////////////////////////////////////////////////////////////
// J[lIuWFNgANX
/////////////////////////////////////////////////////////////////////////////

class CWaitAnyObjects : public CWaitObjectsBase
{
public:
	CWaitAnyObjects()
	{
	}

	CWaitAnyObjects(const IKernelObject &rhs)
		: CWaitObjectsBase(rhs)
	{
	}

	CWaitAnyObjects(const IKernelObject *pRhs)
		: CWaitObjectsBase(pRhs)
	{
	}

	CWaitAnyObjects(const CWaitAnyObjects &rhs)
		: CWaitObjectsBase(rhs)
	{
	}

	CWaitAnyObjects &operator =(const CWaitAnyObjects &rhs)
	{
		Copy(rhs);
		return *this;
	}

	CWaitAnyObjects &operator ||(const IKernelObject &rhs)
	{
		Append(rhs);
		return *this;
	}

	CWaitAnyObjects &operator ||(const IKernelObject *pRhs)
	{
		Append(pRhs);
		return *this;
	}

	const WaitResult Wait(const DWORD dwTimeout = INFINITE, const bool pumpMessage = false) const
	{
		return CWaitObjectsBase::Wait(false, dwTimeout, pumpMessage);
	}
};

class CWaitAllObjects : public CWaitObjectsBase
{
public:
	CWaitAllObjects()
	{
	}

	CWaitAllObjects(const IKernelObject &rhs)
		: CWaitObjectsBase(rhs)
	{
	}

	CWaitAllObjects(const IKernelObject *pRhs)
		: CWaitObjectsBase(pRhs)
	{
	}

	CWaitAllObjects(const CWaitAnyObjects &rhs)
		: CWaitObjectsBase(rhs)
	{
	}

	CWaitAllObjects &operator =(const CWaitAllObjects &rhs)
	{
		Copy(rhs);
		return *this;
	}

	CWaitAllObjects &operator &&(const IKernelObject &rhs)
	{
		Append(rhs);
		return *this;
	}

	CWaitAllObjects &operator &&(const IKernelObject *pRhs)
	{
		Append(pRhs);
		return *this;
	}

	const WaitResult Wait(const DWORD dwTimeout = INFINITE, const bool pumpMessage = false) const
	{
		return CWaitObjectsBase::Wait(true, dwTimeout, pumpMessage);
	}
};

// J[lIuWFNgIAŘAƁAꂩVOiԂɂȂ
// ̂ҋ@o
// ex: result = (ko1 || ko2).Wait(1000);
BONAPI CWaitAnyObjects operator ||(const IKernelObject &lhs, const IKernelObject &rhs);
BONAPI CWaitAnyObjects operator ||(const IKernelObject *pLhs, const IKernelObject &rhs);
BONAPI CWaitAnyObjects operator ||(const IKernelObject &lhs, const IKernelObject *pRhs);

// J[lIuWFNgAhŘAƁAꂩVOiԂɂȂ
// ̂ҋ@o
// ex: result = (ko1 && ko2).Wait(1000);
BONAPI CWaitAllObjects operator &&(const IKernelObject &lhs, const IKernelObject &rhs);
BONAPI CWaitAllObjects operator &&(const IKernelObject *pLhs, const IKernelObject &rhs);
BONAPI CWaitAllObjects operator &&(const IKernelObject &lhs, const IKernelObject *pRhs);

// VB `bNȍ\
// ex: result = WaitFor(ko1 || ko2, 1000);
inline const IWaitableObject::WaitResult WaitFor(
	const IWaitableObject &waitable, const DWORD dwTimeout = INFINITE, const bool pumpMessage = false)
{
	return waitable.Wait(dwTimeout, pumpMessage);
}


/////////////////////////////////////////////////////////////////////////////
// VOiC^[tFCX
/////////////////////////////////////////////////////////////////////////////

class ISignal : public IWaitableObject
{
public:
	virtual const IKernelObject *GetKernelObject() const = 0;

	virtual const bool Set() = 0;
	virtual const bool Reset() = 0;

	virtual operator bool() const = 0;
	virtual bool operator !() const = 0;
};

}
