// BonClassEnumerator.h: BonNX񋓃NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Vector>


/////////////////////////////////////////////////////////////////////////////
// BonNX񋓃NX
/////////////////////////////////////////////////////////////////////////////

class CBonClassEnumerator :	public CBonObject,
							public IBonClassEnumerator
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CBonClassEnumerator)

// IBonClassEnumerator
	virtual const DWORD EnumBonClass(LPCTSTR lpszBIId);
	virtual const DWORD GetBonClassNum(void) const;
	virtual const CBonString GetBonModuleName(DWORD dwIndex) const;
	virtual const CBonString GetBonClassName(DWORD dwIndex) const;
	virtual const CBonString GetBonClassDesc(DWORD dwIndex) const;
	virtual const CBonString GetBonModuleComment(DWORD dwIndex) const;
	virtual const CBonString GetBonModuleAuthor(DWORD dwIndex) const;
	virtual const CBonString GetBonModuleWebsite(DWORD dwIndex) const;

// CBonClassEnumerator
	CBonClassEnumerator(IBonObject *pOwner);
	virtual ~CBonClassEnumerator(void);

protected:
	void ReleaseCatalog(void);

	struct CLASS_CAT_INFO
	{
		IBonModCatalog *pModCatalog;
		DWORD dwClassIndex;
	};

	TCHAR m_szEnumBIId[BON_MAX_CLASS_NAME];
	std::vector<IBonModCatalog *> m_CatalogList;
	std::vector<CLASS_CAT_INFO> m_ClassList;
};
