using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	[ComVisible(true)]
	[Guid("A9B972F2-4A0E-4e24-96D9-CFBEA2DED5C9")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface ITunerDefinition
	{
		string TunerName
		{
			get;
		}

		string DeviceName
		{
			get;
		}

		ITuningSpaceInformation[] TuningSpaces
		{
			get;
		}

		ITuner CreateTuner();
	}
}
