using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Collections;

namespace Bon
{
	[ComVisible(true)]
	[Guid("85C5F3EB-CD88-448d-8BCE-5BEA8827EC10")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface ITunerFactory : IEnumerable
	{
		void Update();

		int Count
		{
			get;
		}

		ITunerDefinition this[int index]
		{
			get;
		}

		new IEnumerator GetEnumerator();
	}
}
