
#pragma once

namespace Bon
{
	ref class ProgramInformation sealed
		: public IProgramInformation
	{
	private:
		initonly int programID_;
		initonly int programVideoID_;
		initonly int programAudioID_;
		initonly int programPcrID_;
		initonly System::String^ serviceName_;
		initonly IEpgData^ epgData_;

	internal:
		ProgramInformation(int programID, int programVideoID, int programAudioID, int programPcrID,
			System::String^ serviceName, IEpgData^ epgData);

	public:
		property int ProgramID
		{
			virtual int get();
		}

		property int ProgramVideoID
		{
			virtual int get();
		}

		property int ProgramAudioID
		{
			virtual int get();
		}

		property int ProgramPcrID
		{
			virtual int get();
		}

		property System::String^ ServiceName
		{
			virtual System::String^ get();
		}

		property IEpgData^ EpgData
		{
			virtual IEpgData^ get();
		}
	};
}
