
#include "stdafx.h"

#include "TunerDefinition.h"
#include "Tuner.h"

namespace Bon
{
	TunerDefinition::TunerDefinition(System::String^ tunerName, System::String^ deviceName,
		array<ITuningSpaceInformation^>^ tuningSpaces)
		: tunerName_(tunerName), deviceName_(deviceName), tuningSpaces_(tuningSpaces)
	{
	}

	System::String^ TunerDefinition::TunerName::get()
	{
		return tunerName_;
	}

	System::String^ TunerDefinition::DeviceName::get()
	{
		return deviceName_;
	}

	array<ITuningSpaceInformation^>^ TunerDefinition::TuningSpaces::get()
	{
		return tuningSpaces_;
	}

	ITuner^ TunerDefinition::CreateTuner()
	{
		return gcnew Tuner(this);
	}
}
