
#pragma once

namespace Bon
{
	ref class TunerDefinition
		: public ITunerDefinition
	{
	private:
		initonly System::String^ tunerName_;
		initonly System::String^ deviceName_;
		initonly array<ITuningSpaceInformation^>^ tuningSpaces_;

	internal:
		TunerDefinition(System::String^ tunerName, System::String^ deviceName,
			array<ITuningSpaceInformation^>^ tuningSpaces);

	public:
		property System::String^ TunerName
		{
			virtual System::String^ get();
		}

		property System::String^ DeviceName
		{
			virtual System::String^ get();
		}

		property array<ITuningSpaceInformation^>^ TuningSpaces
		{
			virtual array<ITuningSpaceInformation^>^ get();
		}

		virtual ITuner^ CreateTuner();
	};
}
