
#pragma once

namespace Bon
{
	ref class Tuner;

	[System::Runtime::InteropServices::ComVisibleAttribute(true)]
	[System::Runtime::InteropServices::GuidAttribute("429F33E9-BB96-492e-B8F9-9C539086FF32")]
	[System::Runtime::InteropServices::ComDefaultInterfaceAttribute(ITunerFactory::typeid)]
	public ref class TunerFactory sealed
		: public ITunerFactory
	{
	private:
		array<ITunerDefinition^>^ tunerDefinitions_;

		void UpdateTunerDefinitions();

	public:
		TunerFactory();

		property int Count
		{
			virtual int get();
		}

		property ITunerDefinition^ default[int]
		{
			virtual ITunerDefinition^ get(int index);
		}

		virtual void Update();

		virtual System::Collections::IEnumerator^ GetEnumerator();
	};
}
