
#include "stdafx.h"

#include "TuningSpaceInformation.h"

namespace Bon
{
	TuningSpaceInformation::TuningSpaceInformation(System::String^ name, array<System::String^>^ channels)
		: name_(name), channels_(channels)
	{
		System::Diagnostics::Debug::Assert(name_ != nullptr);
		System::Diagnostics::Debug::Assert(channels_ != nullptr);
	}

	int TuningSpaceInformation::GetHashCode()
	{
		int result = name_->GetHashCode();
		for (int i = 0; i < channels_->Length; i++)
		{
			result ^= channels_[i]->GetHashCode();
		}
		return result;
	}

	System::String^ TuningSpaceInformation::Name::get()
	{
		return name_;
	}

	array<System::String^>^ TuningSpaceInformation::Channels::get()
	{
		return channels_;
	}
}
