
#pragma once

namespace Bon
{
	ref class TuningSpaceInformation sealed
		: public ITuningSpaceInformation
	{
	private:
		initonly System::String^ name_;
		initonly array<System::String^>^ channels_;

	internal:
		TuningSpaceInformation(System::String^ name, array<System::String^>^ channels);

	public:
		virtual int GetHashCode() override;

		property System::String^ Name
		{
			virtual System::String^ get();
		}

		property array<System::String^>^ Channels
		{
			virtual array<System::String^>^ get();
		}
	};
}
