// BonBlackTuner.h: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Vector>
#include <Queue>
#include "BonEnumerator.h"
#include "BonTunerBase.h"

/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

class CBonBlackTuner :	public CBonTunerBase
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CBonBlackTuner)

// IHalDevice
	virtual const CBonString GetDeviceName() const;

// IHalTsTuner
	virtual const CBonString EnumTuningSpace(const DWORD dwSpace) const;
	virtual const CBonString EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const;

	virtual const bool SetLnbPower(const bool bEnable);
	virtual const float GetSignalLevel(void) const;

// CBonBlackTuner
	CBonBlackTuner(IBonObject *pOwner);
	
protected:
	virtual const bool OnOpenTuner(void);
	virtual const bool OnSetChannel(const DWORD dwSpace, const DWORD dwChannel);
};
