// TsDescriptor.cpp: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsDescriptor.h"
#include <TChar.h>


/////////////////////////////////////////////////////////////////////////////
// ̎NX͋Lqq̃f[^ێAIDescBlockC^tF[X
// NXێ郁ubNQƂB
// ̂߂̃NXIDescBlockC^tF[X擾ĎgpȂ
// ȂȂB(PƂŃCX^X𐶐邱Ƃ͂łȂ)
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access Method LqqNX
/////////////////////////////////////////////////////////////////////////////

const WORD CCaMethodDesc::GetCaMethodID(void) const
{
	// MIDԂ
	return (WORD)m_pDescData[0] << 8 | (WORD)m_pDescData[1];
}

const WORD CCaMethodDesc::GetCaPID(void) const
{
	// MPIDԂ
	return (WORD)(m_pDescData[2] & 0x1FU) << 8 | (WORD)m_pDescData[3];
}

const BYTE * CCaMethodDesc::GetPrivateData(void) const
{
	// vCx[gf[^Ԃ
	return &m_pDescData[4];
}

const BYTE CCaMethodDesc::GetPrivateDataSize(void) const
{
	// vCx[gf[^Ԃ
	return m_byDescLen - 4U;
}

CCaMethodDesc::CCaMethodDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CCaMethodDesc::~CCaMethodDesc(void)
{
	// Ȃ
}

const bool CCaMethodDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 4U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x40] lbg[N LqqC^tF[X
/////////////////////////////////////////////////////////////////////////////

const CBonString CNetworkNameDesc::GetNetworkName() const
{
	// lbg[N`FbN
	if(!m_byDescLen)return CBonString::GetEmpty();

	// lbg[N擾
	return CAribString::AribToString(&m_pDescData[0], m_byDescLen);
}

CNetworkNameDesc::CNetworkNameDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CNetworkNameDesc::~CNetworkNameDesc(void)
{
	// Ȃ
}

const bool CNetworkNameDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 1U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x41] T[rXXg LqqC^tF[X
/////////////////////////////////////////////////////////////////////////////

const DWORD CServiceListDesc::GetServiceNum(void) const
{
	// T[rXԂ
	return m_byDescLen / 3UL;
}

const WORD CServiceListDesc::GetServiceID(const DWORD dwIndex) const
{
	// T[rXIDԂ
	return (dwIndex < GetServiceNum())? ((WORD)m_pDescData[dwIndex * 3] << 8 | (WORD)m_pDescData[dwIndex * 3 + 1]) : 0x0000U;
}

const BYTE CServiceListDesc::GetServiceType(const DWORD dwIndex) const
{
	// T[rX`ʂԂ
	return (dwIndex < GetServiceNum())? m_pDescData[dwIndex * 3 + 2] : 0x00U;
}

CServiceListDesc::CServiceListDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CServiceListDesc::~CServiceListDesc(void)
{
	// Ȃ
}

const bool CServiceListDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen && !(m_byDescLen % 3U))? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x48] Service LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CServiceDesc::GetServiceType(void) const
{
	// T[rX`IDԂ
	return m_pDescData[0];
}

const CBonString CServiceDesc::GetProviderName() const
{
	// ƎҖ`FbN
	const DWORD dwPos = 1UL;
	if(!m_pDescData[dwPos])return CBonString::GetEmpty();

	// ƎҖ擾
	return CAribString::AribToString(&m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);
}

const CBonString CServiceDesc::GetServiceName() const
{
	// T[rX`FbN
	const DWORD dwPos = (DWORD)m_pDescData[1] + 2UL;
	if(!m_pDescData[dwPos])return CBonString::GetEmpty();

	// T[rX擾
	return CAribString::AribToString(&m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);
}

CServiceDesc::CServiceDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CServiceDesc::~CServiceDesc(void)
{
	// Ȃ
}

const bool CServiceDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 3U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x4D] Z`Cxg LqqNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CShortEventDesc::GetLanguageCode(void) const
{
	// R[hԂ
	return ((DWORD)m_pDescData[0] << 16) | ((DWORD)m_pDescData[1] << 8) | (DWORD)m_pDescData[2];
}

const CBonString CShortEventDesc::GetEventName() const
{
	// ԑg`FbN
	const DWORD dwPos = 3UL;
	if(!m_pDescData[dwPos])return CBonString::GetEmpty();

	// ԑg擾
	return CAribString::AribToString(&m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);
}

const CBonString CShortEventDesc::GetEventDesc() const
{
	// ԑgLq`FbN
	const DWORD dwPos = (DWORD)m_pDescData[3] + 4UL;
	if(!m_pDescData[dwPos])return CBonString::GetEmpty();

	// ԑgLq擾
	return CAribString::AribToString(&m_pDescData[dwPos + 1UL], m_pDescData[dwPos]);
}

CShortEventDesc::CShortEventDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CShortEventDesc::~CShortEventDesc(void)
{
	// Ȃ
}

const bool CShortEventDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 5U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x4E] g`Cxg LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CExtendEventDesc::GetDescNumber(void) const
{
	// LqqԍԂ
	return m_pDescData[0] >> 4;
}

const BYTE CExtendEventDesc::GetLastDescNumber(void) const
{
	// ŏILqqԍԂ
	return m_pDescData[0] & 0x0FU;
}

const DWORD CExtendEventDesc::GetLanguageCode(void) const
{
	// R[hԂ
	return ((DWORD)m_pDescData[1] << 16) | ((DWORD)m_pDescData[2] << 8) | (DWORD)m_pDescData[3];
}

const DWORD CExtendEventDesc::GetItemNum(void) const
{
	// ACeԂ
	const BYTE *pItem = &m_pDescData[5];
	DWORD dwItem = 0UL;

	for(DWORD dwPos = 0UL ; dwPos < (DWORD)m_pDescData[4] ; dwItem++){
		// |C^ʒuXV
		if((dwPos + (DWORD)pItem[dwPos] + 1U) >= (DWORD)m_pDescData[4])break;
		dwPos += (DWORD)pItem[dwPos] + 1UL;
		dwPos += (DWORD)pItem[dwPos] + 1UL;
		}
		
	return dwItem;
}

const CBonString CExtendEventDesc::GetItemName(const DWORD dwIndex) const
{
	// ACe|C^擾
	const BYTE *pItem = GetItemPointer(dwIndex);
	if(!pItem)return CBonString::GetEmpty();
	if(!pItem[0])return CBonString::GetEmpty();

	// ACeԂ
	return CAribString::AribToString(&pItem[1], pItem[0]);
}

const DWORD CExtendEventDesc::GetItemText(BYTE *pDst, const DWORD dwIndex) const
{
	// ACe|C^擾
	const BYTE *pItem = GetItemPointer(dwIndex);
	if(!pItem)return 0UL;
	
	pItem = &pItem[(DWORD)pItem[0] + 1UL];
	
	if(!pItem[0])return 0UL;

	// obt@ɃRs[
	if(pDst)::CopyMemory(pDst, &pItem[1], pItem[0]);

	// obt@ɕKvȃoCgԂ
	return pItem[0];	
}

const CBonString CExtendEventDesc::GetExtDesc() const
{
	const BYTE *pItem = &m_pDescData[5];
	DWORD dwPos = 0UL;

	while(true){
		// |C^ʒuXV
		if(dwPos >= (DWORD)m_pDescData[4]){
			// DescriptionȂ
			return CBonString::GetEmpty();
			}
		else if((dwPos + (DWORD)pItem[dwPos] + 1U) >= (DWORD)m_pDescData[4]){
			// Description
			pItem = &pItem[dwPos];
			break;
			}
		else{			
			dwPos += (DWORD)pItem[dwPos] + 1UL;
			dwPos += (DWORD)pItem[dwPos] + 1UL;
			}
		}

	// ACẽeLXgԂ
	return CAribString::AribToString(&pItem[1], pItem[0]);
}

CExtendEventDesc::CExtendEventDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CExtendEventDesc::~CExtendEventDesc(void)
{
	// Ȃ
}

const bool CExtendEventDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 8U)? true : false;
}

const BYTE * CExtendEventDesc::GetItemPointer(const DWORD dwIndex) const
{
	// w肵ACe̐擪|C^Ԃ
	const BYTE *pItem = &m_pDescData[5];
	
	for(DWORD dwPos = 0UL, dwItem = 0UL ; dwPos < (DWORD)m_pDescData[4] ; ){
		if((dwPos + (DWORD)pItem[dwPos] + 1U) >= (DWORD)m_pDescData[4])break;

		if(dwItem++ == dwIndex){
			// CfbNXBA|C^Ԃ
			return &pItem[dwPos];
			}
		else{
			// |C^ʒuXV
			dwPos += (DWORD)pItem[dwPos] + 1UL;
			dwPos += (DWORD)pItem[dwPos] + 1UL;
			}
		}
		
	return NULL;
}


/////////////////////////////////////////////////////////////////////////////
// [0x50] Component LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CComponentDesc::GetStreamContent(void) const
{
	// R|[lgeԂ
	return m_pDescData[0] & 0x0FU;
}

const BYTE CComponentDesc::GetComponentType(void) const
{
	// R|[lg^CvԂ
	return m_pDescData[1];
}

const BYTE CComponentDesc::GetComponentTag(void) const
{
	// R|[lg^OԂ
	return m_pDescData[2];
}

const DWORD CComponentDesc::GetLanguageCode(void) const
{
	// R[hԂ
	return ((WORD)m_pDescData[3] << 16) | ((WORD)m_pDescData[4] << 8) | (WORD)m_pDescData[5];
}

const CBonString CComponentDesc::GetComponentText() const
{
	// R|[lgLqԂ
	if(m_byDescLen < 7U)return CBonString::GetEmpty();
	
	return CAribString::AribToString(&m_pDescData[6], m_byDescLen - 6UL);
}

const bool CComponentDesc::IsVideoComponent(void) const
{
	// R|[lgefɊւ̂ǂԂ
	return (GetStreamContent() == 0x01U)? true : false;
}

const WORD CComponentDesc::GetVideoResolution(void) const
{
	// 𑜓x(̃sNZ)Ԃ
	if(!IsVideoComponent())return 0U;
	
	switch(GetComponentType() & 0x0FU){
		case 0x01U :
		case 0x02U :
		case 0x03U :				
		case 0x04U :
			switch(GetComponentType() & 0xF0U){
				case 0xD0U :	// 240p
					return 240U;

				case 0x00U :	// 480i
				case 0xA0U :	// 480p
					return 480U;
					
				case 0xC0U :	// 720p
					return 720U;
				
				case 0xB0U :	// 1080i
					return 1080U;
				
				default :		// `̉𑜓x
					return 0U;
				}
			break;
		
		default :
			// `̉𑜓x
			return 0U;
		}
}

const bool CComponentDesc::IsVideoProgressive(void) const
{
	// vObVu̗LԂ
	if(!IsVideoComponent())return false;
	
	switch(GetComponentType() & 0x0FU){
		case 0x01U :
		case 0x02U :
		case 0x03U :				
		case 0x04U :
			switch(GetComponentType() & 0xF0U){
				case 0x00U :	// 480i
				case 0xB0U :	// 1080i
					return false;

				case 0xD0U :	// 240p
				case 0xA0U :	// 480p
				case 0xC0U :	// 720p
					return true;

				default :		// `̉𑜓x
					return false;
				}
			break;
		
		default :
			// `̉𑜓x
			return false;
		}
}

const bool CComponentDesc::IsVideoAspectWide(void) const
{
	// AXyNg16:9̗LԂ
	if(!IsVideoComponent())return true;

	switch(GetComponentType() & 0xF0U){
		case 0xD0U :	// 240p
		case 0x00U :	// 480i
		case 0xA0U :	// 480p
		case 0xC0U :	// 720p
		case 0xB0U :	// 1080i
			switch(GetComponentType() & 0x0FU){
				case 0x01U :
					return false;	// 4:3
				
				case 0x02U :
				case 0x03U :				
				case 0x04U :
					return true;	// 16:9
		
				default :
					// `̉𑜓x
					return true;
				}
			break;

		default :	// `̉𑜓x
			return true;
		}
}

const bool CComponentDesc::IsVideoPanAndScan(void) const
{
	// pXL̗LԂ
	if(!IsVideoComponent())return false;

	switch(GetComponentType() & 0xF0U){
		case 0xD0U :	// 240p
		case 0x00U :	// 480i
		case 0xA0U :	// 480p
		case 0xC0U :	// 720p
		case 0xB0U :	// 1080i
			switch(GetComponentType() & 0x0FU){
				case 0x02U :
					return true;	// pxNg
				
				case 0x01U :
				case 0x03U :				
				case 0x04U :
					return false;	// pxNgȂ
		
				default :
					// `̉𑜓x
					return false;
				}
			break;

		default :	// `̉𑜓x
			return false;
		}
}

CComponentDesc::CComponentDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CComponentDesc::~CComponentDesc(void)
{
	// Ȃ
}

const bool CComponentDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen >= 6U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CStreamIdDesc::GetComponentTag(void) const
{
	// R|[lg^OԂ
	return m_pDescData[0];
}

CStreamIdDesc::CStreamIdDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CStreamIdDesc::~CStreamIdDesc(void)
{
	// Ȃ
}

const bool CStreamIdDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen == 1U)? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x54] Content LqqNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CContentDesc::GetGenreNum(void) const
{
	// W̐Ԃ
	return m_byDescLen / 2U;
}

const BYTE CContentDesc::GetGenreLevel1(const DWORD dwIndex) const
{
	// W1Ԃ
	return (dwIndex < GetGenreNum())? (m_pDescData[dwIndex / 2UL + 0UL] >> 4) : 0x0FU;
}

const BYTE CContentDesc::GetGenreLevel2(const DWORD dwIndex) const
{
	// W2Ԃ
	return (dwIndex < GetGenreNum())? (m_pDescData[dwIndex / 2UL + 0UL] & 0x0F) : 0x0FU;
}

const BYTE CContentDesc::GetUserGenre1(const DWORD dwIndex) const
{
	// [UW1Ԃ
	return (dwIndex < GetGenreNum())? (m_pDescData[dwIndex / 2UL + 1UL] >> 4) : 0x0FU;
}

const BYTE CContentDesc::GetUserGenre2(const DWORD dwIndex) const
{
	// [UW2Ԃ
	return (dwIndex < GetGenreNum())? (m_pDescData[dwIndex / 2UL + 1UL] & 0x0F) : 0x0FU;
}

CContentDesc::CContentDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CContentDesc::~CContentDesc(void)
{
	// Ȃ
}

const bool CContentDesc::ParseData(void)
{
	// TCŶ݃`FbN
	return (m_byDescLen && !(m_byDescLen % 2U))? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// [0xC4]  Component LqqNX
/////////////////////////////////////////////////////////////////////////////

const BYTE CAudioComponentDesc::GetComponentType(void) const
{
	// R|[lgʂԂ
	return m_pDescData[1];
}

const BYTE CAudioComponentDesc::GetComponentTag(void) const
{
	// R|[lg^OԂ
	return m_pDescData[2];
}

const BYTE CAudioComponentDesc::GetStreamType(void) const
{
	// Xg[`Ԃ
	return m_pDescData[3];
}

const BYTE CAudioComponentDesc::GetSimulcastGroupTag(void) const
{
	// TC}LXgO[v^OԂ
	return m_pDescData[4];
}

const bool CAudioComponentDesc::IsEsMultiLanguage(void) const
{
	// EStOԂ
	return (m_pDescData[5] & 0x80U)? true : false;
}

const bool CAudioComponentDesc::IsMainComponent(void) const
{
	// R|[lgtOԂ
	return (m_pDescData[5] & 0x40U)? true : false;
}

const BYTE CAudioComponentDesc::GetQualityIndicator(void) const
{
	// \Ԃ
	return (m_pDescData[5] >> 4) & 0x03U;
}

const BYTE CAudioComponentDesc::GetSamplingRate(void) const
{
	// TvOgԂ
	return (m_pDescData[5] >> 1) & 0x07U;
}

const DWORD CAudioComponentDesc::GetMainLanguageCode(void) const
{
	// 1̌R[hԂ
	return ((WORD)m_pDescData[6] << 16) | ((WORD)m_pDescData[7] << 8) | (WORD)m_pDescData[8];
}

const DWORD CAudioComponentDesc::GetSubLanguageCode(void) const
{
	// 2̌R[hԂ
	if(IsEsMultiLanguage() && (m_byDescLen >= 12U)){
		// 2
		return ((WORD)m_pDescData[9] << 16) | ((WORD)m_pDescData[10] << 8) | (WORD)m_pDescData[11];
		}
	else{
		// 2Ȃ
		return 0x00000000UL;
		}
}

const CBonString CAudioComponentDesc::GetComponentText() const
{
	if(IsEsMultiLanguage() && (m_byDescLen >= 13U)){
		// 2
		return CAribString::AribToString(&m_pDescData[12], m_byDescLen - 12UL);
		}
	else if(m_byDescLen >= 10U){
		// 2Ȃ
		return CAribString::AribToString(&m_pDescData[9], m_byDescLen - 9UL);
		}
	else{
		// R|[lgLqȂ
		return CBonString::GetEmpty();
		}
}

const bool CAudioComponentDesc::IsDualMonoMode(void) const
{
	// d̗LԂ
	return (GetComponentType() == 0x02U)? true : false;
}

const bool CAudioComponentDesc::IsEnableCenter(void) const
{
	// Z^[Xs[J[̗L
	switch(GetComponentType()){
		case 0x01U :	// 1/0
		case 0x02U :	// 1/0+1/0
		case 0x05U :	// 3/0
		case 0x07U :	// 3/1
		case 0x08U :	// 3/2
		case 0x09U :	// 3/2+LFE
			return true;
		
		default	:
			return false;		
		}
}

const bool CAudioComponentDesc::IsEnableFront(void) const
{
	// tgCXs[J[̗L
	switch(GetComponentType()){
		case 0x03U :	// 2/0		Stereo
		case 0x04U :	// 2/1
		case 0x05U :	// 3/0
		case 0x06U :	// 2/2
		case 0x07U :	// 3/1
		case 0x08U :	// 3/2
		case 0x09U :	// 3/2+LFE
			return true;
		
		default	:
			return false;		
		}
}

const bool CAudioComponentDesc::IsEnableSurround(void) const
{
	// ATEhXs[J[̗L
	switch(GetComponentType()){
		case 0x04U :	// 2/1
		case 0x06U :	// 2/2
		case 0x07U :	// 3/1
		case 0x08U :	// 3/2
		case 0x09U :	// 3/2+LFE
			return true;
		
		default	:
			return false;		
		}
}

const bool CAudioComponentDesc::IsEnableLFE(void) const
{
	// LFEXs[J[̗L
	switch(GetComponentType()){
		case 0x09U :	// 3/2+LFE
			return true;
		
		default	:
			return false;		
		}
}

CAudioComponentDesc::CAudioComponentDesc(IBonObject *pOwner)
	: CDescBase(pOwner)
{
	// Ȃ
}

CAudioComponentDesc::~CAudioComponentDesc(void)
{
	// Ȃ
}

const bool CAudioComponentDesc::ParseData(void)
{
	// TCŶ݃`FbN
	if(m_byDescLen < 9U){
		// TCYs
		return false;
		}
	else if(IsEsMultiLanguage()){
		// 2
		return (m_byDescLen >= 12U)? true : false;
		}
	else{
		// 2Ȃ
		return (m_byDescLen >= 9U)? true : false;
		}
}
