// TsSrcManager.cpp: TS\[X}l[WNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsSrcManager.h"


/////////////////////////////////////////////////////////////////////////////
// TS\[X}l[WNX
/////////////////////////////////////////////////////////////////////////////

const bool CTsSrcManager::OpenManager(void)
{
	// UN[Y
	CloseManager();
	
	// NX񋓃CX^X
	m_pDriverCollection = ::BON_SAFE_CREATE<IBonClassEnumerator *>(TEXT("CBonClassEnumerator"));
	::BON_ASSERT(m_pDriverCollection != NULL);

	// IHalTsTunerNX
	m_pDriverCollection->EnumBonClass(TEXT("IHalTsTuner"));
	
	
	return true;
}

void CTsSrcManager::CloseManager(void)
{
	// NX񋓃CX^XJ
	BON_SAFE_RELEASE(m_pDriverCollection);


}

IHalTsTuner * CTsSrcManager::LendTuner(const DWORD dwIndex)
{
	return NULL;
}

const bool CTsSrcManager::RepayTuner(IHalTsTuner *pTsTuner)
{
	return true;
}

const CBonString CTsSrcManager::GetClassName(const DWORD dwIndex)
{
	return CBonString::GetEmpty();
}

const CBonString CTsSrcManager::GetTunerName(const DWORD dwIndex)
{
	return CBonString::GetEmpty();
}

const DWORD CTsSrcManager::GetTunerIndex(const DWORD dwIndex)
{
	return 0UL;
}

const bool CTsSrcManager::IsTunerLending(const DWORD dwIndex)
{
	return true;
}

CTsSrcManager::CTsSrcManager(IBonObject *pOwner)
	: CBonObject(pOwner)
	, m_pDriverCollection(NULL)
{


}

CTsSrcManager::~CTsSrcManager(void)
{
	// }l[WN[Y
	CloseManager();
}
