// TsSrcManager.h: TS\[X}l[WNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <vector>


/////////////////////////////////////////////////////////////////////////////
// TS\[X}l[WNX
/////////////////////////////////////////////////////////////////////////////

class CTsSrcManager	:	public CBonObject
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsSrcManager)

// ITsSrcManager
	virtual const bool OpenManager(void);
	virtual void CloseManager(void);

	virtual IHalTsTuner * LendTuner(const DWORD dwIndex);
	virtual const bool RepayTuner(IHalTsTuner *pTsTuner);

	virtual const CBonString GetClassName(const DWORD dwIndex);
	virtual const CBonString GetTunerName(const DWORD dwIndex);
	virtual const DWORD GetTunerIndex(const DWORD dwIndex);
	virtual const bool IsTunerLending(const DWORD dwIndex);

// CTsSrcManager
	CTsSrcManager(IBonObject *pOwner);
	virtual ~CTsSrcManager(void);
	
protected:
	struct TSSRC_SET
	{
		IHalTsTuner *pTsTuner;
		DWORD dwTunerIndex;
		bool bIsLend;
	};
	
	IBonClassEnumerator *m_pDriverCollection;
	std::vector<TSSRC_SET> m_TsSourceSet;
};
